//
//   bas.c
//
//   Oliver Fromme  <olli@fromme.com>
//   @(#)$Id: bas.c,v 1.1 1998/12/11 02:07:30 olli Exp $
//

static const char cvsid[]
    = "@(#)$Id: bas.c,v 1.1 1998/12/11 02:07:30 olli Exp $";

#include <stdio.h>
#include <signal.h>

#include "bas.h"

char *
time_format (int secs)
{
	static char buffer[32];
	unsigned days, hours, mins;

	days = secs / 86400;
	secs = secs % 86400;
	hours = secs / 3600;
	secs = secs % 3600;
	mins = secs / 60;
	secs = secs % 60;
	if (days)
		sprintf (buffer, "%ud %u:%02u:%02u", days, hours, mins, secs);
	else
		sprintf (buffer, "%u:%02u:%02u", hours, mins, secs);
	return buffer;
}

//
//   Signal handler stuff
//   ====================
//
//   We're defining our own catchsignal() function instead
//   of using signal(), because the latter has non-portable
//   semantics between SysV and BSD.
//   catchsignal() implements the BSD-style semantics, which
//   means that the disposition of the signal is maintained
//   after a call of the signal handling function.
//

sighandler
catchsignal (int signum, sighandler handler)
{
	struct sigaction new_sa;
	struct sigaction old_sa;

	new_sa.sa_handler = handler;
	sigemptyset (&new_sa.sa_mask);
	new_sa.sa_flags = 0;
	if (sigaction(signum, &new_sa, &old_sa) == -1)
		return SIG_ERR;
	return old_sa.sa_handler;
}

//-- 
