//
//   lst.h
//
//   Oliver Fromme  <olli@fromme.com>
//   @(#)$Id: lst.h,v 1.1 1998/12/04 09:04:43 olli Exp $
//

#ifndef HAVE_LST_H
#define HAVE_LST_H

static const char cvsid_lst_h[]
    = "@(#)$Id: lst.h,v 1.1 1998/12/04 09:04:43 olli Exp $";

typedef int jobfunc(void *entry, void *data);

typedef struct {
	int count;		//   number of entries
	void **list;		//   the actual entries
} simple_list;

#define simple_list_add_string(l,s) simple_list_add(l, s, strlen(s) + 1)
#define TRAVERSE_IGNORERESULT	0x0001	//   ignore result of job

void simple_list_init (simple_list *l);
void simple_list_add (simple_list *l, void *new, int size);
int  simple_list_count (simple_list *l);
int  simple_list_traverse (simple_list *l, jobfunc *job, void *jobdata,
	unsigned flags);
void simple_list_done (simple_list *l);

int    csv_count (char *csv);
char * csv_value (char *csv, int n);
int    csv_traverse (char *csv, jobfunc *job, void *jobdata, unsigned flags);

#endif // HAVE_LST_H

//-- 
