//
//   pro.h
//
//   Oliver Fromme  <olli@fromme.com>
//   @(#)$Id: pro.h,v 1.3 1998/12/11 02:14:45 olli Exp $
//

#ifndef HAVE_PRO_H
#define HAVE_PRO_H

static const char cvsid_pro_h[]
    = "@(#)$Id: pro.h,v 1.3 1998/12/11 02:14:45 olli Exp $";

#include "bas.h"

//
//   Macro to calculate the difference between two "struct timeval".
//   Note that `old' must be smaller (i.e. older) than `new'.
//   `diff' may be the same as either `old' or `new'.
//

#define TIMEVALDIFF(old,new,diff) \
	do { \
		diff.tv_sec = new.tv_sec - old.tv_sec; \
		if (new.tv_usec >= old.tv_usec) \
			diff.tv_usec = new.tv_usec - old.tv_usec; \
		else { \
			diff.tv_usec = 1000000 - (old.tv_usec - new.tv_usec); \
			diff.tv_sec--; \
		} \
	} while (0)

#define PROCMD_SETSIZE	0
#define PROCMD_START	1
#define PROCMD_UPDATE	2
#define PROCMD_STOP	3

void init_progress (void);
int done_progress (void);
void command_progress (ulonglong cmd, ulonglong par);
#define setsize_progress(total)	command_progress(PROCMD_SETSIZE, total)
#define start_progress()	command_progress(PROCMD_START, 0)
#define update_progress(part)	command_progress(PROCMD_UPDATE, part)
#define stop_progress()		command_progress(PROCMD_STOP, 0)

#endif // HAVE_PRO_H

//-- 
