//
//   stt.h
//
//   Oliver Fromme  <olli@fromme.com>
//   @(#)$Id: stt.h,v 1.2 1998/12/11 02:11:03 olli Exp $
//

#ifndef HAVE_STT_H
#define HAVE_STT_H

static const char cvsid_stt_h[]
    = "@(#)$Id: stt.h,v 1.2 1998/12/11 02:11:03 olli Exp $";

#include <sys/types.h>
#include <time.h>

#include "bas.h"

typedef struct {
	time_t start, end;		// start and end time of the job
	unsigned errors;		// number of errors occured
	unsigned totalpairs;		// total number of remote/local trees
	unsigned totalsites;		// total number of mirrored sites
	unsigned totalchanges;		// total number of changes

	ulonglong totalbytes;		// total bytes in the mirror
	unsigned totalfiles;		// total plain files in the mirror
	unsigned totaldirs;		// total directories in the mirror
	unsigned totallinks;		// total symlinks in the mirror

	ulonglong gonebytes;		// bytes removed
	unsigned gonefiles;		// files removed
	unsigned gonedirs;		// directories removed
	unsigned gonelinks;		// symlinks removed

	ulonglong newbytes;		// new bytes retrieved
	unsigned newfiles;		// new files retrieved
	unsigned newdirs;		// new directories created
	unsigned newlinks;		// new symlinks created

	ulonglong updbytes;		// bytes updated
	unsigned updfiles;		// files updated
	unsigned upddirs;		// directories updated
	unsigned updlinks;		// symlinks updated

	unsigned permfiles;		// files permission changed
	unsigned permdirs;		// directories permission changed

	longlong growbytes;		// growth in bytes
	ulonglong xferbytes;		// bytes actually transferred
	double xfertime;		// data transfer time (seconds)
} omistats;

//
//   Global statistics, and pointer to the current statistics.
//

extern omistats globalstats;
extern omistats *cs;

void stats_init (omistats *os);
void stats_done (omistats *os);
void stats_summary (omistats *sum, omistats *x);
void stats_report (omistats *os, char *site, char *remote, char *local);
char * ulkformat (unsigned long ulk);
char * lkformat (long lk);
char * xferrate_report (double duration, ulonglong bytes);

#endif // HAVE_STT_H

//-- 
